package java.lang.management;

import sun.management.LockInfoCompositeData;
import javax.management.openmbean.CompositeData;

public class LockInfo
{
    private String className;
    private int identityHashCode;
    
    public LockInfo(String className, int identityHashCode) {
        if (className == null) {
            throw new NullPointerException("Parameter className cannot be null");
        }
        this.className = className;
        this.identityHashCode = identityHashCode;
        return;
    }
    
    LockInfo(Object o) {
        this.className = o.getClass().getName();
        this.identityHashCode = System.identityHashCode(o);
    }
    
    public String getClassName() {
        return this.className;
    }
    
    public int getIdentityHashCode() {
        return this.identityHashCode;
    }
    
    public static LockInfo from(CompositeData cd) {
        if (cd == null) {
            return null;
        }
        if ((cd instanceof LockInfoCompositeData)) {
            return ((LockInfoCompositeData)cd).getLockInfo();
        }
        return LockInfoCompositeData.toLockInfo(cd);
    }
    
    @Override
    public String toString() {
        return this.className + 64 + Integer.toHexString(this.identityHashCode);
    }
}
